#!/bin/bash

chmod +x solvers/aspicV3.4
chmod +x solvers/lsting
chmod +x best_configs.sh


echo "------------------Building the artifact------------------"
cd src
javac -cp ../gurobi/linux64/lib/gurobi.jar:. Main.java

cd ..
jar cfm artifact.jar src/META-INF/MANIFEST.MF src/*.class
echo "------------------Artifact Build finished successfully------------------"


if [ -d "psi" ]; then
    echo "------------------Fetching & Building PSI------------------"
    cd psi 
    git clone https://github.com/eth-sri/psi.git
    mv psi PSI-core
    cd PSI-core
    ./dependencies-release.sh && ./build-release.sh
    echo "------------------PSI Built Successfully------------------"
fi