import os.path


benchmarks = ["cost-analysis-table-3/1-simple-example", "cost-analysis-table-3/2-nested-loop", "cost-analysis-table-3/3-random-walk", "cost-analysis-table-3/4-goods-discount", "cost-analysis-table-3/5-pollutant-disposal", "cost-analysis-table-3/6-2d-robot", "cost-analysis-table-3/7-bitcoin-mining", "cost-analysis-table-3/8-bitcoint-mining-pool", "cost-analysis-table-3/9-species-fight", "cost-analysis-table-3/10-queuing"
              , "higher-moment-tail-prob/1-coupon1", "higher-moment-tail-prob/2-coupon4", "higher-moment-tail-prob/3-random_walk_1d_intvalued", "higher-moment-tail-prob/4-random_walk_1d_realvalued", "higher-moment-tail-prob/5-random_walk_1d_adversary", "higher-moment-tail-prob/6-random_walk_2d_demonic", "higher-moment-tail-prob/7-random_walk_2d_variant"\
                , "motivating/1-retransmission"]



def get_psi_result(loc):
    if not os.path.isfile(loc+"/psi_time.txt"):
        return (False,0)
    p_time = 0 
    with open(loc+"/psi_time.txt",'r') as fr:
        lines = fr.readlines()
        for line in lines:
            if "real\t" in line:
                T = line.split("\t")[1][:-2]
                (M,S)=T.split('m')
                p_time=int(M)*60+float(S)
    succeed = False
    with open(loc+"/psi_final_output.psi",'r') as fr:
        lines = fr.readlines()
        for line in lines:
            if "Equivalence Refuted Successfully" in line:
                succeed=True
    return (succeed,p_time)


def get_artifact_eq_result(loc):
    if not os.path.isfile(loc+"/artifact_equivalence_output.txt"):
        return (False,0)
    a_time = 0
    succeed = False 
    with open(loc+"/artifact_equivalence_output.txt",'r') as fr:
        lines = fr.readlines()
        for line in lines: 
            if "Successfully refuted equivalence" in line:
                succeed = True 
            if "total time used:" in line: 
                a_time = int(line.split(' ')[-1][:-1])
    return (succeed, float(a_time)/1000)

def get_artifact_ds_result(loc):
    if not os.path.isfile(loc+"/artifact_distance_output.txt"):
        return (False,0)
    a_time = 0
    succeed = False 
    distance = "0"
    with open(loc+"/artifact_distance_output.txt",'r') as fr:
        lines = fr.readlines()
        for line in lines: 
            if "Succesfully refuted similarity" in line:
                succeed = True 
            if "Distance found" in line:
                distance = float(line.split(' ')[-1][:-1])
            if "total time used:" in line: 
                a_time = int(line.split(' ')[-1][:-1])
    return (succeed,distance, float(a_time)/1000)






dir = "outputs/inputs/Table-1/"
with open("table-1-results.csv",'w') as fw:
    fw.write("benchmark, loop size, our eq result, our eq time, our ds result, our ds time, PSI result, PSI time\n")
    for bench  in benchmarks:
        fw.write(bench)
        for lim in ["10","100","1000","original"]:
            (psi_result, psi_time)=get_psi_result(dir+lim+"/"+bench)
            (artifact_eq_result, artifact_eq_time)=get_artifact_eq_result(dir+lim+"/"+bench)
            (artifact_ds_result, artifact_ds, artifact_ds_time) = get_artifact_ds_result(dir+lim+"/"+bench)
            if artifact_ds_result==False:
                artifact_ds="-"
            else:
                artifact_ds=round(artifact_ds, 3)
            if psi_result==False:
                psi_time="-"
            fw.write(", "+lim+", "
                     +str(artifact_eq_result)+", "+str(artifact_eq_time)+", "
                     +str(artifact_ds)+", "+str(artifact_ds_time)+", " 
                      +str(psi_result)+", "+str(psi_time)+"\n")
            # break
        # break
    
